<?php

header('Access-Control-Allow-Origin: *');

header('Access-Control-Allow-Methods: GET, POST, OPTIONS');

header('Access-Control-Allow-Headers: Origin, Content-Type, Accept, Authorization, X-Request-With');

//header('Access-Control-Allow-Credentials: true');



date_default_timezone_set("Asia/Kolkata");

require_once 'include/config.php';



$contentType = isset($_SERVER["CONTENT_TYPE"]) ? trim($_SERVER["CONTENT_TYPE"]) : '';

$response = array();

$cart_item = "";



function doItemCalc($price, $quantity, $gst, $couponDiscount) {

	$total = array();

	

	$total['item_price'] = $price;

	$total['item_total_price'] = $price * $quantity;

	if ($couponDiscount) {

		 //$total['item_discount_amount'] = ($total['item_total_price'] / 100) * $couponDiscount;

		// $total['item_discount_amount'] = $max_dicount_amt;

		// $total['item_total_after_discount'] = $total['item_total_price'] - (($total['item_total_price'] / 100) * $couponDiscount);

		 $total['item_total_after_discount'] = $total['item_total_price'] - $max_dicount_amt;

	} else {

		$total['item_discount_amount'] = 0;

		$total['item_total_after_discount'] = $total['item_total_price'];

	}

	$total['item_gst_amount'] = (($total['item_total_after_discount'] / 100) * $gst);

	$total['item_total_after_gst'] = $total['item_total_after_discount'] + (($total['item_total_after_discount'] / 100) * $gst);

	

	return $total;

}



function findCartTotal($cart) {

	$totalAmount = 0;

	foreach ($cart as $cart_item) {

		

		$p_quantity = $cart_item->product_quantity;

		$p_price = $cart_item->product_price;

		

		$totalAmount += $p_quantity * $p_price;

	}

	return $totalAmount;

}



function updateProductQuantity($connection, $code, $size, $quantity, $productDetails) {

	

	if (!$productDetails) {

		$productDetails = $connection->query("SELECT * FROM products WHERE product_code = '$code'")->fetch_assoc();

	}

	

	if($productDetails['size']) {

		$allSizes = explode(",", $productDetails['size']);

		$allQuantities = explode(",", $productDetails['quantity']);

		

		foreach ($allSizes as $index => $allSize) {

			if ($size == $allSize) {

				$allQuantities[$index] = $allQuantities[$index] - $quantity;

			}

		}

		

		$finalQuantities = implode(",", $allQuantities);

		$update = $connection->query("UPDATE products SET quantity = '$finalQuantities' WHERE product_code = '$code'");

	} else {

		$update = $connection->query("UPDATE products SET quantity = quantity - $quantity WHERE product_code = '$code'");

	}

}



if ($contentType === "application/json") {

	//Receive the RAW post data.

	$content = trim(file_get_contents("php://input"));

	$decoded = json_decode($content);

	

	/*** $decoded->data will have everything personal ***/

	/*** $decoded->cart will have cart items in it ***/

	/*** $decoded->coupon will have all the coupon details if any ***/

	

	$name = htmlspecialchars($connection->real_escape_string($decoded->data->name));

	$walletUsername = htmlspecialchars($connection->real_escape_string($decoded->data->walletUsername));
	
	$pincode = htmlspecialchars($connection->real_escape_string($decoded->data->pincode));

	$walletPhone = htmlspecialchars($connection->real_escape_string($decoded->data->walletPhone));

	$walletEmail = htmlspecialchars($connection->real_escape_string($decoded->data->walletEmail));

	$email = htmlspecialchars($connection->real_escape_string($decoded->data->email));

	$phone = htmlspecialchars($connection->real_escape_string($decoded->data->phone));

	$address = htmlspecialchars($connection->real_escape_string($decoded->data->address));

	$uniqueId = htmlspecialchars($connection->real_escape_string($decoded->data->uniqueId));

	$subtotal = (float)htmlspecialchars($connection->real_escape_string($decoded->data->subtotal));

	$amount = (float)htmlspecialchars($connection->real_escape_string($decoded->data->total));

	$payment_method = htmlspecialchars($connection->real_escape_string($decoded->data->payment_method));

	$type = htmlspecialchars($connection->real_escape_string($decoded->data->type));

	$cashback = htmlspecialchars($connection->real_escape_string($decoded->data->cashback));

    $house = htmlspecialchars($connection->real_escape_string($decoded->data->house));

	$landmark = htmlspecialchars($connection->real_escape_string($decoded->data->landmark));
	
	$city = htmlspecialchars($connection->real_escape_string($decoded->data->city));



	$order_type = htmlspecialchars($connection->real_escape_string($decoded->data->order_type));



	$delivery_charge = htmlspecialchars($connection->real_escape_string($decoded->data->delivery_charge));

	$commission = htmlspecialchars($connection->real_escape_string($decoded->data->commission));

	$c_address = htmlspecialchars($connection->real_escape_string($decoded->data->c_address));

	$delivery_date = htmlspecialchars($connection->real_escape_string($decoded->data->delivery_date));

	$delivery_time = htmlspecialchars($connection->real_escape_string($decoded->data->delivery_time));
	$delivery = htmlspecialchars($connection->real_escape_string($decoded->data->delivery));

//	$giftWrap = htmlspecialchars($connection->real_escape_string($decoded->data->gift_wrap));

//	$giftWrapPrice = (float)htmlspecialchars($connection->real_escape_string($decoded->data->gift_wrap_price));

	$guest_checkout = htmlspecialchars($connection->real_escape_string($decoded->data->guest_checkout));

	$couponCode = htmlspecialchars($connection->real_escape_string($decoded->coupon->coupon_code));

	

	$today = date('Y-m-d');

	$order_date = date('Y-m-d H:i:s');

	

	$soProceed = false;

	

	$couponDiscount = 0;

	$totalAmount = 0;

	$coupon = null;

	

	$order_id = "SOHORDS" . rand(10000,99999999);



	/*$gift_wrap = "false";

	if($giftWrap != "true") {

		$giftWrap = 0;

	} else {

		$giftWrap = 25;

		$gift_wrap = "true";

	}*/
            $ordcode = $connection->query("SELECT max(id) FROM temporder")->fetch_array();
			$l_id = $ordcode[0]+1;


	if (($payment_method == "wallet" && $guest_checkout == "true") || (empty($walletUsername) && $payment_method == "wallet")) {

		$response = array(

			"status" => 5,

			"msg" => "please select payment method again",

		);

		echo json_encode($response);

		die();

	}

	

	if (!empty($couponCode)) {

		$isCoupon = $connection->query("SELECT * FROM coupons WHERE coupon_code = '$couponCode'

		AND expiry_date >= '$today' AND status = 'A' AND type='coupon'");

		$coupon = $isCoupon->fetch_assoc();

		

		if ($coupon['min_limit'] <= findCartTotal($decoded->cart)) {

			$couponDiscount = $coupon['total_discount'];

			$cop_amount = ($amount*$couponDiscount)/100;

			if($coupon["max_discount"] < $cop_amount){

               

					$max_dicount_amt = $coupon["max_discount"];

			}



		else{

             $max_dicount_amt = $cop_amount;

			}

		}

	}

	

	if (!empty($name) && !empty($phone) && !empty($address) && !empty($uniqueId) && !empty($amount)

		&& !empty($type) && !empty($payment_method) && (!empty($walletUsername) || !empty($guest_checkout))) {

		

		if ($payment_method === "online") {

			

			foreach ($decoded->cart as $cart_item) {

				

				$p_name = $cart_item->product_name;

				$p_quantity = $cart_item->product_quantity;

				$p_price = $cart_item->product_price;

				$p_code = $cart_item->product_code;

				$p_color = $cart_item->product_color;

				$p_size = $cart_item->product_size;

				$p_gst = $cart_item->product_gst;

				$p_combo = $cart_item->combo_product;

				

				$p_name = str_replace("'", "\'", $p_name);

				$productDetails = $connection->query("SELECT * FROM products WHERE product_code = '$p_code'")->fetch_assoc();

				

				

				/*** updating product quantity after ordered ***/

			updateProductQuantity($connection, $p_code, $p_size, $p_quantity, $productDetails);

			

				

				$item_total_amount = doItemCalc($p_price, $p_quantity, $p_gst, $couponDiscount);

				$all_items_total_after_gst += $item_total_amount['item_total_after_gst'];

				$all_item_total_without_coupon_gst += $item_total_amount['item_total_price'];

				

				$sql .= "INSERT INTO order_details (name,product_code,price,quantity, combo_product, color,size,option1_name,option1_value,uniqueId,

					transactionId,phone,order_date) VALUES ('$p_name','$p_code','$p_price','$p_quantity', '$p_combo','$p_color',

					'$p_size','','','$uniqueId','$uniqueId','$phone','$order_date');";

			}

			

			if ($coupon['min_limit'] <= $totalAmount) {

				$withoutDiscount = $totalAmount;

				$totalAmount = $totalAmount - ($totalAmount / $couponDiscount);

			} else {

				$withoutDiscount = $totalAmount;

				$totalAmount = $totalAmount;

				$couponDiscount = 0;

			}

//

//			$totalAmount = $all_items_total_after_gst + $giftWrapPrice;

//			$withoutDiscount = $all_item_total_without_coupon_gst + $giftWrapPrice;

			// $totalAmount = $all_items_total_after_gst;

			$totalAmount = $all_items_total_after_gst-$max_dicount_amt;

			$withoutDiscount = $all_item_total_without_coupon_gst;

			

			$sql .= "INSERT INTO temporder (username, name, email, address, payment_method, phone, amount,

					total_without_coupon, gift_wrap, gift_wrap_charges, coupon_discount, coupon_code, shipping_charges, uniqueId,

					payment_status, order_status, txnid, type, order_type, reward, order_date,delivery_charge,customer_id,order_id,commission,c_address, delivery_time, delivery_date, house, landmark,delivery,pincode,city) VALUES('$walletUsername', '$name',

					'$email','$address','online','$phone', '$amount','$subtotal','', '','$max_dicount_amt',

					'$couponCode','0','$uniqueId','Not Started','Not Started', '$uniqueId','$type','Shopping','0','$order_date','$delivery_charge','$customer_id','$order_id','$commission','$c_address', '$delivery_time', '$delivery_date','$house','$landmark','$delivery','$pincode','$city');";

			

			$soProceed = true;

			

		} elseif ($payment_method === "wallet") {

			//$a = "SELECT * FROM user_wallet WHERE phone ='$walletPhone' AND username = '$walletUsername' AND email='$email'";

			$haveBalance = $connection->query("SELECT * FROM user_wallet WHERE phone ='$walletPhone' AND username = '$walletUsername' AND email='$email'");

			

			if ($haveBalance->num_rows === 1) {

				

				$walletDetails = $haveBalance->fetch_assoc();

				$currentBalance = $walletDetails['balance'];

				

				if ($currentBalance >= $amount) {

					

					foreach ($decoded->cart as $cart_item) {

						

						$p_name = $cart_item->product_name;

						$p_quantity = $cart_item->product_quantity;

						$p_price = $cart_item->product_price;

						$p_code = $cart_item->product_code;

						$p_color = $cart_item->product_color;

						$p_size = $cart_item->product_size;

						$p_gst = $cart_item->product_gst;

						$p_combo = $cart_item->combo_product;

						
						$p_name = str_replace("'", "\'", $p_name);
						$productDetails = $connection->query("SELECT * FROM products WHERE product_code = '$p_code'")->fetch_assoc();

				

				

				/*** updating product quantity after ordered ***/

			updateProductQuantity($connection, $p_code, $p_size, $p_quantity, $productDetails);

			

						

						$item_total_amount = doItemCalc($p_price, $p_quantity, $p_gst, $couponDiscount);

						$all_items_total_after_gst += $item_total_amount['item_total_after_gst'];

						$all_item_total_without_coupon_gst += $item_total_amount['item_total_price'];

						

						$sql .= "INSERT INTO order_details (name,product_code,price,quantity, combo_product,color,size,option1_name,option1_value,uniqueId,

							transactionId, phone,order_date) VALUES ('$p_name','$p_code','$p_price','$p_quantity', '$p_combo','$p_color',

							'$p_size','','','$uniqueId','$uniqueId','$phone','$order_date');";



					// $sql .= "SELECT * FROM products WHERE product_code ='$p_code';";



			  //         $fetch = mysqli_query($connection,$sql);

			  //          while($row = mysqli_fetch_array($fetch)){

			  //         //$row = mysqli_fetch_array($fetch);

			  //            $qunty = $row['quantity'];

			  //            $size1 = $row['size'];

			  //            $exp_q = explode(',',$qunty);

			  //            $exp_s = explode(',',$size1);



			  //            for($j=0; $j<count($exp_q); $j++)

			  //            {

			  //             if($exp_s[$j] == $p_size)

			  //             {

			  //              $exp_q[$j] =  $exp_q[$j]-$p_quantity;

			  //             }



			  //             $qunty = implode(",",$exp_q);



			  //            }

			  //             $qry_updt = mysqli_query($connection, "UPDATE products SET quantity = '$qunty' where product_code='$p_code' ");

			  //          }

			  //        $check = mysqli_query($connection,$sql);

					// 	$i++;

						// var_dump($sql);

						//die();



							}

//

//					$totalAmount = $all_items_total_after_gst + $giftWrapPrice;

//					$withoutDiscount = $all_item_total_without_coupon_gst + $giftWrapPrice;

					// $totalAmount = $all_items_total_after_gst;

			        $totalAmount = $all_items_total_after_gst-$max_dicount_amt;

			        $total_with_deliverycharge =  $totalAmount + $delivery_charge;

					$withoutDiscount = $all_item_total_without_coupon_gst;

					

					$sql .= "INSERT INTO temporder (username, name, email, address, payment_method, phone, amount,

					total_without_coupon, gift_wrap, gift_wrap_charges, coupon_discount, coupon_code, shipping_charges, uniqueId,

					payment_status, order_status, txnid, type, order_type, reward, order_date,delivery_charge,cashback,customer_id,order_id,commission,c_address, delivery_time, delivery_date, house, landmark,delivery,pincode,city) VALUES('$walletUsername', '$name',

					'$email','$address','Wallet','$phone', '$amount','$subtotal','','',

					'$max_dicount_amt', '$couponCode','0','$uniqueId','success','Not Started', '$uniqueId','$type','Shopping','0',

					'$order_date','$delivery_charge','$cashback' ,'$customer_id','$order_id','$commission','$c_address', '$delivery_time', '$delivery_date', '$house', '$landmark','$delivery','$pincode','$city');";

					

					$sql .= "UPDATE user_wallet SET balance = balance - ' $total_with_deliverycharge' WHERE phone = '$walletPhone' AND

						username = '$walletUsername';";

					

					$soProceed = true;

				} else {

					$soProceed = false;

					$response = array(

						'status' => 3,

						'msg' => "You do not have enough balance in your wallet.",

					);

				}

			} else {

				$soProceed = false;

				$response = array(

					'status' => 4,

					'msg' => "NO wallet account found.",

					//'sql' => $a

 				);

			}

		} elseif ($payment_method == "cod") {

			

			

			foreach ($decoded->cart as $cart_item) {

				

				$p_name = $cart_item->product_name;

				$p_quantity = $cart_item->product_quantity;

				$p_price = $cart_item->product_price;

				$p_code = $cart_item->product_code;

				$p_color = $cart_item->product_color;

				$p_size = $cart_item->product_size;

				$p_gst = $cart_item->product_gst;

				$p_combo = $cart_item->combo_product;

				
					$p_name = str_replace("'", "\'", $p_name);
				$productDetails = $connection->query("SELECT * FROM products WHERE product_code = '$p_code'")->fetch_assoc();

				

				

				/*** updating product quantity after ordered ***/

			updateProductQuantity($connection, $p_code, $p_size, $p_quantity, $productDetails);

			

				

				$item_total_amount = doItemCalc($p_price, $p_quantity, $p_gst, $couponDiscount);

				$all_items_total_after_gst += $item_total_amount['item_total_after_gst'];

				$all_item_total_without_coupon_gst += $item_total_amount['item_total_price'];

				

				$sql .= "INSERT INTO order_details (name,product_code,price,quantity, combo_product,color,size,option1_name,option1_value,uniqueId,

					transactionId,phone,order_date) VALUES ('$p_name','$p_code','$p_price','$p_quantity','$p_combo','$p_color','$p_size','','','$uniqueId','$uniqueId','$phone','$order_date');";



					// $sql .= "SELECT * FROM products WHERE product_code ='$p_code';";



			  //         $fetch = mysqli_query($connection,$sql);

			  //         // while($row = mysqli_fetch_array($fetch)){

			  //         $row = mysqli_fetch_array($fetch);

			  //            $qunty = $row['quantity'];

			  //            $size1 = $row['size'];

			  //            $exp_q = explode(',',$qunty);

			  //            $exp_s = explode(',',$size1);



			  //            for($j=0; $j<count($exp_q); $j++)

			  //            {

			  //             if($exp_s[$j] == $p_size)

			  //             {

			  //              $exp_q[$j] =  $exp_q[$j]-$p_quantity;

			  //             }



			  //             $qunty = implode(",",$exp_q);



			  //            }

			  //             $qry_updt = mysqli_query($connection, "UPDATE products SET quantity = '$qunty' where product_code='$p_code' ");

			  //         // }

			  //        $check = mysqli_query($connection,$sql);

					// 	$i++;

						// var_dump($sql);

						//die();

					 



			}





//

//			$totalAmount = $all_items_total_after_gst + $giftWrapPrice;

//			$withoutDiscount = $all_item_total_without_coupon_gst + $giftWrapPrice;

			$totalAmount = $all_items_total_after_gst-$max_dicount_amt;

			$withoutDiscount = $all_item_total_without_coupon_gst;

			

			$sql .= "INSERT INTO temporder (username, name, email, address, payment_method, phone, amount,

					total_without_coupon, gift_wrap, gift_wrap_charges, coupon_discount, coupon_code, shipping_charges, uniqueId,

					payment_status, order_status, txnid, type, order_type, reward, order_date,delivery_charge,cashback,customer_id,order_id,commission,c_address, delivery_time, delivery_date,house,landmark,delivery,pincode,city) VALUES('$walletUsername', '$name',

					'$email','$address','COD','$phone', '$amount','$subtotal','','',

					'$max_dicount_amt', '$couponCode','0','$uniqueId','Cash On Delivery','Not Started', '$uniqueId',

					'$type','Shopping','0','$order_date','$delivery_charge','$cashback' ,'$customer_id','$order_id','$commission','$c_address', '$delivery_time', '$delivery_date','$house','$landmark','$delivery','$pincode','$city');";

			

			$soProceed = true;

		}

		

		elseif ($payment_method == "scrap") {

			

			

			foreach ($decoded->cart as $cart_item) {

				

				$p_name = $cart_item->product_name;

				$p_quantity = $cart_item->product_quantity;

				$p_price = $cart_item->product_price;

				$p_code = $cart_item->product_code;

				$p_color = $cart_item->product_color;

				$p_size = $cart_item->product_size;

				$p_gst = $cart_item->product_gst;

				$p_combo = $cart_item->combo_product;

				

				$item_total_amount = doItemCalc($p_price, $p_quantity, $p_gst, $couponDiscount);

				$all_items_total_after_gst += $item_total_amount['item_total_after_gst'];

				$all_item_total_without_coupon_gst += $item_total_amount['item_total_price'];

				

				$sql .= "INSERT INTO order_details (name,product_code,price,quantity, combo_product,color,size,uniqueId,

					transactionId,phone,order_date) VALUES ('$p_name','$p_code','$p_price','$p_quantity','$p_combo','$p_color','$p_size','$uniqueId','$uniqueId','$phone','$order_date');";



					// $sql .= "SELECT * FROM products WHERE product_code ='$p_code';";



			  //         $fetch = mysqli_query($connection,$sql);

			  //          while($row = mysqli_fetch_array($fetch)){

			  //         //$row = mysqli_fetch_array($fetch)



			  //            $qunty = $row['quantity'];

			  //            $size1 = $row['size'];

			  //            $exp_q = explode(',',$qunty);

			  //            $exp_s = explode(',',$size1);



			  //            for($j=0; $j<count($exp_q); $j++)

			  //            {

			  //             if($exp_s[$j] == $p_size)

			  //             {

			  //              $exp_q[$j] =  $exp_q[$j]-$p_quantity;

			  //             }



			  //             $qunty = implode(",",$exp_q);



			  //            }

			  //             $qry_updt = mysqli_query($connection, "UPDATE products SET quantity = '$qunty' where product_code='$p_code' ");

			  //         }



					// 	// var_dump($sql);

					// 	$check = mysqli_query($connection,$sql);

					// 	$i++;

			}

//

//			$totalAmount = $all_items_total_after_gst + $giftWrapPrice;

//			$withoutDiscount = $all_item_total_without_coupon_gst + $giftWrapPrice;

			// $totalAmount = $all_items_total_after_gst;

			$totalAmount = $all_items_total_after_gst-$max_dicount_amt;

			$withoutDiscount = $all_item_total_without_coupon_gst;

			

			$sql .= "INSERT INTO temporder (username, name, email, address, payment_method, phone, amount,

					total_without_coupon, gift_wrap, gift_wrap_charges, coupon_discount, coupon_code, shipping_charges, uniqueId,

					payment_status, order_status, txnid, type, order_type, reward, order_date,delivery_charge,cashback,customer_id,order_id, delivery_time, delivery_date,house,landmark,pincode,city) VALUES('$walletUsername', '$name',

					'$email','$address','Scrap','$phone', '$amount','$subtotal','','',

					'$max_dicount_amt', '$couponCode','0','$uniqueId','Scrap','Not Started', '$uniqueId',

					'$type','Shopping','0','$order_date','$delivery_charge','$cashback' ,'$customer_id','$order_id', '$delivery_time', '$delivery_date','$house','$landmark','$pincode','$city');";

			

			$soProceed = true;

		}

		if ($soProceed === true) {

			//newOrderAdminSMS($uniqueId);


				if($payment_method == "cod" || $payment_method == "wallet"){
					newOrderCustomerSMS($phone,$l_id,$amount);
					newOrderAdminSMS($l_id);
				}

			$query = $connection->multi_query($sql);


			if ($query === true) {

				$response = array(

					"status" => 1,

					"msg" => "Success",

					"uniqueId" => $uniqueId,
				// 	"last_id" = mysqli_insert_id($connection),
					   //'last_id' = $connection->lastInsertId(),

				// 	"last_id" =>  $connection->insert_id,

				);

			} else {

				$response = array(

					"status" => 2,

					"msg" => "unexpected error",
					"sql" => $sql,
					

				);

			}

			

		}

	} else {

		$response = array(

			"status" => 0,

			"msg" => "empty fields",

			'a' => $decoded

		);

	}

} else {

	$response = array(

		"status" => 99,

		"msg" => "unauthorised access",

	);

}

// echo json_encode($sql);

echo json_encode($response);

